
from AccessControl import ClassSecurityInfo
from Products.CMFCore.permissions import View
from Globals import InitializeClass
from Products.CMFCore.utils import getToolByName
import config
from Products.ATSchemaEditorNG.ParentManagedSchema import ParentManagedSchema
from Products.Archetypes.utils import  DisplayList



class GenericParentManagedSchema(ParentManagedSchema):
    """ mix-in class for AT content-types whose schema is managed by
        the parent container and retrieved through acquisition.
    """

    global_allow = 0
    security = ClassSecurityInfo()
    
    def lookup_provider(self):
        """ return schema provider instance """
        portal_schemamanager=getToolByName(self,'portal_schemamanager')	
	schema_type = getattr(self.aq_base, 'schema_type', self.getTypeInfo().id)
	if ( not hasattr(self.aq_base, 'schema_type')) and (not schema_type in portal_schemamanager.precreated_models):
	    self._v_schema = None
	    self.setSchemaType(schema_type)
	generic_container=portal_schemamanager[schema_type]
        return generic_container
	
    def _lookupChanges(self, atse_schema_id):
        """ Checks if schema has changed """
	generic_container=getToolByName(self,'portal_schemamanager')[getattr(self.aq_base, 'schema_type',self.getTypeInfo().id)]
        return generic_container.atse_getSchemaById(atse_schema_id)

    def setSchemaType(self,schema_type):
	self.schema_type = schema_type

    def automatic_vocabulary(self,**kw):
	portal_type=self.aq_base.portal_type
	method_name='vocabulary_'+portal_type+'_'+kw['field'].getName()
	vocabulary_method=getattr(self,method_name,[])
	if vocabulary_method:
		vocabulary_method=vocabulary_method()
	#vocabulary_method = [ (str(item[0]),item[1])  for item in vocabulary_method]
    	return DisplayList(vocabulary_method)
	
    def automatic_default(self,**kw):
        if not hasattr(self,'num'):
            setattr(self,'num',0)
	schema_type=self.aq_base.schema_type
        folder=getattr(self,'DefaultFields',None)
        method_name='default_'+schema_type.lower()+'_'+str(self.num/2)
        if not hasattr(folder,method_name):
            setattr(self,'num',0)
            method_name='default_'+schema_type.lower()+'_'+str(self.num/2)
        value=getattr(folder,method_name,'')
        setattr(self,'num',self.num+1)

        return value(self)

    def SearchableText(self):
        "Returns a concatanation of all searchable text"

        ret = ""
	for field in self.Schema().filterFields(isMetadata=0):
		val = field.get(self)
		if val:
			ret += str(val) + ' '

        return ret
	
InitializeClass(GenericParentManagedSchema)
