try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *



from Products.Archetypes.interfaces.metadata import IExtensibleMetadata
from Products.ATSchemaEditorNG.SchemaEditor import SchemaEditor
from Products.CMFPlone.interfaces.Translatable import ITranslatable
from Products.CMFCore import permissions

import Products

if hasattr(Products,'PloneArticle_no'):
	plone_article_available = 1
else:
	plone_article_available = 0

if plone_article_available:
	from Products.PloneArticle.PloneArticle import PloneArticle
	from Products.PloneArticle.ArticleCore import ArticleContents
#	from Products.PloneArticle.PloneArticle import ArticleLock
#	from Products.PloneArticle.BaseArchetypesArticle import BaseArchetypesArticle

if hasattr(Products,'PloneExFile'):
	plone_exfile_available = 1
else:
	plone_exfile_available = 0

if plone_exfile_available:
	from Products.PloneExFile.ExFile import PloneExFile


# 	
# if hasattr(Products,'ATContentTypes'):
# 	atcontenttypes_available = 1
# else:
# 	atcontenttypes_available = 0
# 
	
from webdav.WriteLockInterface import WriteLockInterface
from webdav.LockItem import LockItem

from AccessControl import ClassSecurityInfo
import string
from Products.GenericPloneContent.GenericParentManagedSchema import GenericParentManagedSchema
from Products.GenericPloneContent.DefaultOverriding import DefaultOverriding

if plone_article_available:
	class GenericArticleContent(GenericParentManagedSchema,PloneArticle):
		"""An Archetype example type"""
		
		# Since we have customized the default Metadata schema into ArticleInfos...
		#schema = BaseContentMixin.schema # + .... (add your own schemas)
		#schema = BaseContent.schema
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Article Content"
		#     schema = BaseSchema
		#                                        #
		security = ClassSecurityInfo()
		security.declareProtected(permissions.View, 'SearchableText')
		def SearchableText(self):
			"Returns a concatenation of all searchable text"
			ret = ""
			for field in self.Schema().filterFields(isMetadata=0):
				val = field.get(self)
				if val:
					ret += str(val) + ' '
			ret += string.join(map(lambda x: x.SearchableText(), self.listAttachments()), " ") + " "
			ret += string.join(map(lambda x: x.title_or_id(), self.listImages()), " ")
			return ret
		
	
	registerType(GenericArticleContent)

from Products.ATContentTypes.content.base import ATCTContent
class GenericContent(DefaultOverriding, GenericParentManagedSchema,ATCTContent,):
    """ Target content type to edit schema on """
    meta_type = portal_type = "Generic Content"

registerType(GenericContent)

from Products.ATContentTypes.content.folder import ATFolder
class GenericFolder(ATFolder, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Folder"
	Schema = GenericParentManagedSchema.Schema

registerType(GenericFolder)

# if atcontenttypes_available:
from Products.ATContentTypes.content.document import ATDocument
class GenericDocument(DefaultOverriding, ATDocument, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Document"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericDocument)

from Products.ATContentTypes.content.event import ATEvent
class GenericEvent(ATEvent, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Event"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericEvent)

from Products.ATContentTypes.content.file import ATFile
class GenericFile(ATFile, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic File"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericFile)

from Products.ATContentTypes.content.favorite import ATFavorite
class GenericFavorite(ATFavorite, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Favorite"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericFavorite)

from Products.ATContentTypes.content.image import ATImage
class GenericImage(ATImage, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Image"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericImage)

from Products.ATContentTypes.content.link import ATLink
class GenericLink(ATLink, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Link"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericLink)

from Products.ATContentTypes.content.newsitem import ATNewsItem
class GenericNewsItem(ATNewsItem, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic NewsItem"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericNewsItem)

from Products.ATContentTypes.content.topic import ATTopic
class GenericTopic(ATTopic, GenericParentManagedSchema):
	""" Target content type to edit schema on """
	meta_type = portal_type = "Generic Topic"
	Schema = GenericParentManagedSchema.Schema
registerType(GenericTopic)
	
	
	
if plone_exfile_available:
	class GenericExFile(PloneExFile,GenericParentManagedSchema):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic ExFile"
		Schema = GenericParentManagedSchema.Schema
	registerType(GenericExFile)

